(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('angular2-materialize-v1', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = global || self, factory(global['angular2-materialize-v1'] = {}, global.ng.core, global.ng.common));
}(this, (function (exports, i0, common) { 'use strict';

    var Angular2MaterializeV1Service = /** @class */ (function () {
        // tslint:disable-next-line:ban-types
        function Angular2MaterializeV1Service(platformId) {
            this.platformId = platformId;
        }
        Angular2MaterializeV1Service.getElements = function (elements) {
            if (elements.charAt(0) === '#') {
                elements = elements.replace('#', '');
                return document.getElementById(elements);
            }
            return document.querySelectorAll(elements);
        };
        Angular2MaterializeV1Service.prototype.autoInit = function () {
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.AutoInit();
        };
        Angular2MaterializeV1Service.prototype.dismissAllToasts = function () {
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Toast.dismissAll();
        };
        Angular2MaterializeV1Service.prototype.initAutocomplete = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Autocomplete.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initCarousel = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Carousel.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initCharacterCount = function (elements) {
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.CharacterCounter.init(Angular2MaterializeV1Service.getElements(elements));
        };
        Angular2MaterializeV1Service.prototype.initChips = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Chips.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initCollapsible = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Collapsible.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initDatepicker = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Datepicker.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initDropdown = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Dropdown.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initFloatingActionButton = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.FloatingActionButton.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initMaterialbox = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Materialbox.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initModal = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Modal.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initParallax = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Parallax.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initPushpin = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            var elms = Angular2MaterializeV1Service.getElements(elements);
            if (elms instanceof NodeList && !options.offset) {
                var ret = [];
                // tslint:disable-next-line:prefer-for-of
                for (var i = 0; i < elms.length; ++i) {
                    options.offset = elms[i].offsetTop;
                    ret.push(M.Pushpin.init(elms[i], options));
                }
                return ret;
            }
            else if (elms instanceof HTMLElement && !options.offset) {
                options.offset = elms.offsetTop;
                return M.Pushpin.init(elms, options);
            }
            else {
                return M.Pushpin.init(elms, options);
            }
        };
        Angular2MaterializeV1Service.prototype.initScrollSpy = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.ScrollSpy.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initSelect = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.FormSelect.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initSidenav = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Sidenav.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initSlider = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Slider.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initTabs = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Tabs.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initTapTarget = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.TapTarget.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initTimepicker = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Timepicker.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.initTooltip = function (elements, options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.Tooltip.init(Angular2MaterializeV1Service.getElements(elements), options);
        };
        Angular2MaterializeV1Service.prototype.toast = function (options) {
            if (options === void 0) { options = {}; }
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.toast(options);
        };
        Angular2MaterializeV1Service.prototype.textareaAutoResize = function () {
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.textareaAutoResize();
        };
        Angular2MaterializeV1Service.prototype.updateTextFields = function () {
            if (common.isPlatformServer(this.platformId)) {
                return null;
            }
            return M.updateTextFields();
        };
        return Angular2MaterializeV1Service;
    }());
    Angular2MaterializeV1Service.ɵprov = i0.ɵɵdefineInjectable({ factory: function Angular2MaterializeV1Service_Factory() { return new Angular2MaterializeV1Service(i0.ɵɵinject(i0.PLATFORM_ID)); }, token: Angular2MaterializeV1Service, providedIn: "root" });
    Angular2MaterializeV1Service.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    Angular2MaterializeV1Service.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: i0.Inject, args: [i0.PLATFORM_ID,] }] }
    ]; };

    /*
     * Public API Surface of angular2-materialize-v1
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.Angular2MaterializeV1Service = Angular2MaterializeV1Service;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular2-materialize-v1.umd.js.map
