import { ɵɵdefineInjectable, ɵɵinject, PLATFORM_ID, Injectable, Inject } from '@angular/core';
import { isPlatformServer } from '@angular/common';

class Angular2MaterializeV1Service {
    // tslint:disable-next-line:ban-types
    constructor(platformId) {
        this.platformId = platformId;
    }
    static getElements(elements) {
        if (elements.charAt(0) === '#') {
            elements = elements.replace('#', '');
            return document.getElementById(elements);
        }
        return document.querySelectorAll(elements);
    }
    autoInit() {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.AutoInit();
    }
    dismissAllToasts() {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Toast.dismissAll();
    }
    initAutocomplete(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Autocomplete.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initCarousel(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Carousel.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initCharacterCount(elements) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.CharacterCounter.init(Angular2MaterializeV1Service.getElements(elements));
    }
    initChips(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Chips.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initCollapsible(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Collapsible.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initDatepicker(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Datepicker.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initDropdown(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Dropdown.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initFloatingActionButton(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.FloatingActionButton.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initMaterialbox(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Materialbox.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initModal(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Modal.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initParallax(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Parallax.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initPushpin(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        const elms = Angular2MaterializeV1Service.getElements(elements);
        if (elms instanceof NodeList && !options.offset) {
            const ret = [];
            // tslint:disable-next-line:prefer-for-of
            for (let i = 0; i < elms.length; ++i) {
                options.offset = elms[i].offsetTop;
                ret.push(M.Pushpin.init(elms[i], options));
            }
            return ret;
        }
        else if (elms instanceof HTMLElement && !options.offset) {
            options.offset = elms.offsetTop;
            return M.Pushpin.init(elms, options);
        }
        else {
            return M.Pushpin.init(elms, options);
        }
    }
    initScrollSpy(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.ScrollSpy.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initSelect(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.FormSelect.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initSidenav(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Sidenav.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initSlider(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Slider.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initTabs(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Tabs.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initTapTarget(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.TapTarget.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initTimepicker(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Timepicker.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    initTooltip(elements, options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Tooltip.init(Angular2MaterializeV1Service.getElements(elements), options);
    }
    toast(options = {}) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.toast(options);
    }
    textareaAutoResize() {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.textareaAutoResize();
    }
    updateTextFields() {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.updateTextFields();
    }
}
Angular2MaterializeV1Service.ɵprov = ɵɵdefineInjectable({ factory: function Angular2MaterializeV1Service_Factory() { return new Angular2MaterializeV1Service(ɵɵinject(PLATFORM_ID)); }, token: Angular2MaterializeV1Service, providedIn: "root" });
Angular2MaterializeV1Service.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
Angular2MaterializeV1Service.ctorParameters = () => [
    { type: Object, decorators: [{ type: Inject, args: [PLATFORM_ID,] }] }
];

/*
 * Public API Surface of angular2-materialize-v1
 */

/**
 * Generated bundle index. Do not edit.
 */

export { Angular2MaterializeV1Service };
//# sourceMappingURL=angular2-materialize-v1.js.map
